//
// Landscape rendering
//
//
//                                  Andrea "6502" Griffini, programmer
//                                         agriff@ix.netcom.com
//                                      http://vv.val.net/~agriffini
//
#include <stdio.h>
#include <dos.h>
#include <conio.h>
#include <stdlib.h>
#include <math.h>


#include <keydefs.h>


#define byte unsigned char
#define uchar unsigned char
#define uint unsigned int
#define vbuf (uchar *)0xA0000000
#define I asm


#define D 0.5
#define H_SHIFT 15
// half of the xy field of view
#define FOV ( M_PI / 3.5 )


// HMap:  Height field
// CMap:  Color map
// Video: Off-screen buffer

byte HMap[65535], CMap[65535], Video[65535], back[65535];

long lasty[320],         // Last pixel drawn on a given column
     lastc[320];         // Color of last pixel on a column



/////////////////////////////////////////////
// Routines per la gestione della tastiera //
/////////////////////////////////////////////

// vettore dei tasti
unsigned char key[128];
// puntatore alla vecchia funzione di interrupt
void interrupt (*old_int9)(...);
static uint far
*fp_kbd_tail = (uint far*)MK_FP(0x40, 0x1A),
*fp_kbd_head = (uint far*)MK_FP(0x40, 0x1C);
int kb_hit = 0;


void interrupt new_int9(...)
{
unsigned char a;

    a = inp(0x60);  // legge il codice del tasto ed aggiorna il vettore "key"
    kb_hit = a;
    if (a & 0x80)
     key[a & 0x7F] = 0;
    else
     key[a & 0x7F] = 1;

*fp_kbd_tail = *fp_kbd_head; // resetta il buffer della tastiera

old_int9(); // consente la vecchia routine di interrupt
}

void keyhook(char m)
{
static char hooked;
int i;
for(i=0; i<128; i++) key[i] = 0;

if(!hooked && m)
 {
  old_int9 = getvect(9);
  setvect(9, new_int9);
  hooked=1;
 } else

if(hooked && !m) setvect(9, old_int9);
}
/////////////////////////////////////////////







#define WORD uint
void move_screen(uchar *src, uchar *dest, uint len)
{
WORD src_s, src_o;
WORD dest_s, dest_o;
src_s = FP_SEG(src);
src_o = FP_OFF(src);
dest_s = FP_SEG(dest);
dest_o = FP_OFF(dest);

asm{
push si
push di
push ds

mov cx, len
shr cx, 1


push dest_s
pop  es
mov di, dest_o

push src_s
pop  ds
mov si, src_o


   cld
   rep movsw


pop  ds
pop di
pop si
}

}


void clear_page(void)
{
uint v_seg = FP_SEG(Video);
asm{
push di

push v_seg
pop es
xor di, di
mov cx, 32000
xor ax, ax
cld
rep stosw

pop di
}
}

void back_to_page(long xo)
{
uint off=0;
uint yy;
int x, ix;
xo = (xo+65536L) % 160;

for(yy=0; yy<320*100; yy+=160)
for(ix=0, x=xo; ix<160; ix++, x++)
{
 if(x>160) x-=160;
 *((int *)Video+off) = *((int *)back + yy+x);
 off++;
}

}


int Clamp(int x)
{
  return (x<0 ? 0 : (x>255 ? 255 : x));
}


void ComputeCMap(void)
{
int i, j, k;
uint off=0;
 for ( j=0; j<256; j++ )
  for ( i=0; i<256; i++, off++ )
    {
      k = 128 + (
	  (int)HMap[((i+1) << 8) + ((j+1) & 255)] -
	  (int)HMap[i*256+j] );
      k = Clamp(k);
      CMap[i*256+j] = k;
    }
}



void ComputeMap(void)
{
  uint i;
  int p, j, ii;

for(i=0; i<65530; i+=rand()%4)
 HMap[i] = ((rand()%256) / 2) * (rand()%3);

 for ( p=0; p<4; p++ )
    for ( i=0, ii=0; ii<256; ii++, i+=256 )
      for ( j=0; j<256; j++ )
      {
	HMap[i+j]=(HMap[((i+256) & 0xFF00)+j]+HMap[i+((j+1) & 0xFF)]+
		   HMap[((i-256) & 0xFF00)+j]+HMap[i+((j-1) & 0xFF)]) >> 2;
      }

for(i=0; i<65535; i++) HMap[i] = Clamp((HMap[i])*8);

ComputeCMap();


}



void calc_back(void)
{
int ix, iy, x, y;
int b=1;
uint off=0;
int i, j;
for(iy=0; iy<200; iy++, off++)
for(ix=0; ix<320; ix+=b, off+=b)
{
 back[off] = rand()%(255-iy);
 b=rand()%5+1;
}

for(ix=0; ix<5; ix++)
for(j=0; j<200; j++)
for(i=0; i<160; i++)
 back[i+j*320]
	 =((int)back[(i+1)%160+j*320] +
	   (int)back[(i+320-1)%160+j*320] +
	   (int)back[320*((j+1)%200)+i] +
	   (int)back[320*((j-1+200)%200)+i] ) >> 2;


off=0;
for(iy=0; iy<200; iy++)
for(ix=0; ix<320; ix++, off++)
Video[off]=back[(ix/16)+(iy/2)*320];

for(off=0; off<64000; off++) back[off]=Clamp((Video[off]-rand()%32)*2);


for(ix=0; ix<8; ix++)
for(j=0; j<200; j++)
for(i=0; i<320; i++)
 back[i+j*320]
	 =((int)back[(i+1)%320+j*320] +
	   (int)back[(i+320-1)%320+j*320] +
	   (int)back[320*((j+1)%200)+i] +
	   (int)back[320*((j-1+200)%200)+i] ) >> 2;

for(off=0; off<64000; off++) back[off]=Clamp(back[off]+128+64);


}


void draw_column(int y, int i, long c, int pos)
{
int aa = lasty[i];


    if ( y < aa )
    {
     int sc, cc;
     byte *v = Video + (aa-1)*320 + i;


      if ( lastc[i]==-1 )  lastc[i] = c;

      sc = (( c - lastc[i] ) / ( aa - y )) >> 10;
      cc = lastc[i] >> 10;

      if ( aa > 199 ) {
		       aa-=199;
		       v-=aa * 320;
		       cc+=aa * sc;
		       aa = 199;
		      }

      if ( y < 0 ) y = 0;


      while ( y < aa )
      {
	*v = cc >> 8;
	cc+=sc;
	v-=320;
	aa--;
      }
      lasty[i] = y;

    }
    lastc[i] = c;
}



//
// Draw a "section" of the landscape; x0,y0 and x1,y1 and the xy coordinates
// on the height field, hy is the viewpoint height, s is the scaling factor
// for the distance. x0,y0,x1,y1 are 16.16 fixed point numbers and the
// scaling factor is a 16.8 fixed point value.
//
void Line(long x0,long y0,long x1,long y1,long hy,long s)
{
  int i;
  long sx,sy;

  // Compute xy speed
  sx = (x1 - x0) / 320L;
  sy = (y1 - y0) / 320L;
  for ( i=0; i<320; i++ )
  {
    long c, y, a, b;
    long h, h0, h1, h2, h3;
    unsigned int u0, v0, u1, v1;

    //
    // Compute the xy coordinates; a and b will be the position inside the
    // single map cell (0..255).
    //
    u0 = (x0 >> 16) & 0xFF;
    v0 = ((y0 >> 8) & 0xFF00);

    //h = HMap[u0+v0];
    //c = 255*65535 - (h << 16);

    u1 = (u0 + 1) & 0xFF;
    v1 = (v0 + 256) & 0xFF00;
    a = (x0 >> 8) & 255;
    b = (y0 >> 8) & 255;


    //
    // Fetch the height at the four corners of the square the point is in
    //
    h0 = HMap[u0 + v0];
    h1 = HMap[u1 + v0];
    h2 = HMap[u0 + v1];
    h3 = HMap[u1 + v1];

    //
    // Compute the height using bilinear interpolation
    //
    h0 = (h0 << 8) + a * (h1 - h0);
    h2 = (h2 << 8) + a * (h3 - h2);
    h = ((h0 << 8) + b * (h2 - h0));
    //c=255*65535-h;
    h>>=H_SHIFT;

    //
    // Fetch the color at the four corners of the square the point is in
    //

    h0 = CMap[u0 + v0];
    h1 = CMap[u1 + v0];
    h2 = CMap[u0 + v1];
    h3 = CMap[u1 + v1];

    //
    // Compute the color using bilinear interpolation (in 16.16)
    //
    h0 = (h0 << 8) + a * (h1 - h0);
    h2 = (h2 << 8) + a * (h3 - h2);
    c = ((h0 << 8) + b * (h2 - h0));

    //
    // Compute screen height using the scaling factor
    //
    y=( ((h - hy) * s) >> 11 ) + 100;

    //
    // Draw the column
    //
draw_column(y, i, c, (x0+y0) >> 16);
    //
    // Advance to next xy position
    //
    x0+=sx;
    y0+=sy;

  }
}











//
// Draw the view from the point x0,y0 (16.16) looking at angle a
//
void View(long x0,long y0, float aa)
{
  long d;
  long a, b;
  long h, h0, h1, h2, h3;
  uint u0, v0, u1, v1;

  //
  // Clear offscreen buffer
  //

back_to_page(320.0/M_PI*aa);
//clear_page();


  //
  // Initialize last-y and last-color arrays
  //
  int i;
  for ( i=0; i<320; i++ )
  {
    lasty[i] = 200;
    lastc[i] = -1;
  }

  //
  // Compute viewpoint height value
  //

  //
  // Compute the xy coordinates; a and b will be the position inside the
  // single map cell (0..255).
  //
  u0 = (x0 >> 16) & 0xFF;
  v0 = ((y0 >> 8) & 0xFF00);
  u1 = (u0 + 1) & 0xFF;
  v1 = (v0 + 256) & 0xFF00;
  a = (x0 >> 8) & 255;
  b = (y0 >> 8) & 255;

  //
  // Fetch the height at the four corners of the square the point is in
  //
  h0 = HMap[u0 + v0];
  h1 = HMap[u1 + v0];
  h2 = HMap[u0 + v1];
  h3 = HMap[u1 + v1];

  //
  // Compute the height using bilinear interpolation
  //
  h0 = (h0 << 8) + a * (h1 - h0);
  h2 = (h2 << 8) + a * (h3 - h2);
  h = ((h0 << 8) + b * (h2 - h0));
  h>>=H_SHIFT;

  //
  // Draw the landscape from near to far without overdraw
  //
  for ( d=0; d<40; )
  {
    Line(x0 + d * 65536.0 * cos(aa-FOV)*D,
	 y0 + d * 65536.0 * sin(aa-FOV)*D,
	 x0 + d * 65536.0 * cos(aa+FOV)*D,
	 y0 + d * 65536.0 * sin(aa+FOV)*D,
	 h-35,  120 * 256 / (d*2 + 4) );

 d++;
 if(d>15) d++;
 if(d>25) d+=2;
 if(d>32) d+=3;

  }


  move_screen(Video, vbuf, 64000);
}


void set_pal(void)
{
int i;
outp(968,0);
  for ( i=0; i<128; i++ )
  {
    outp(969,i);
    outp(969,(i+1)/2);
    outp(969,0);
  }
for ( i=0; i<64; i++ )
  {
    outp(969,0);
    outp(969,0);
    outp(969,i);
  }
for ( i=0; i<64; i++ )
  {
    outp(969,i);
    outp(969,i);
    outp(969,63);
  }
}














void main(void)
{
int i, k;
float a, as, s, ss, x, y;
int turn_angle=0;
int moving_fd=1;
int moving_bk=0;
int turning_rt=0;
int turning_lt=0;
int running=0;
long autom=0;


asm mov ax, 13h
asm int 10h


set_pal();

ComputeMap();

calc_back();


  a=0;
  as=0;
  s=4;
  ss=0;
  x=128;
  y=128;

  keyhook(1);

  while(!key[KEY_ESC])
  {

    View(x*65535, y*65535, a);


    x+=s * cos(a);
    y+=s * sin(a);
    s+=ss;
    a+=as;

    if(kb_hit) autom = 128;
    if(autom > 0) autom--;

    if(!autom)
    {

     if( (rand()%25==0) || (!moving_fd && !moving_bk && !turn_angle) )
      { turn_angle = (rand()%512 - 256) / (rand()%16+1);
	turn_angle*=rand()%2; }

     if(turn_angle < 0)
      { turn_angle++; turning_rt = 1; turning_lt = 0; }

     if(turn_angle > 0)
      { turn_angle--; turning_rt = 0; turning_lt = 1; }

     if(!turn_angle)
      { turning_rt = turning_lt = 0; }

     if(rand()%50==1) moving_fd=rand()%4;

    }

     else

    {
     turning_rt = key[KEY_RIGHT];
     turning_lt = key[KEY_LEFT];
     moving_fd = key[KEY_UP];
     moving_bk = key[KEY_DOWN];
     running = key[KEY_Z];
    }



    if(!turning_lt && !turning_rt) if(as) as/=1.25;

    if(turning_lt)
     if(as > -M_PI/32.0) as-=0.02;

    if(turning_rt)
     if(as <  M_PI/32.0) as+=0.02;


    if(!moving_fd && !moving_bk) {ss/1.5; s/=1.5;}

    if(moving_fd) s = 0.2;

    if(moving_bk) s=-0.2;


    if(running) s*=2.0;

  }

  keyhook(0);

  //
  // Exit to text mode
  //
  asm mov ax, 3
  asm int 10h
}
